 DEFINE PAGE00, SPACE=ROM
 SEGMENT PAGE00

 include "KnightOS.inc"

 public PutChar, DrawString, MeasureString, ResetTextLocation
 extern DEMulA, Font, PutSpriteOR

ResetTextLocation:
	push hl
	ld hl, 0
	ld (TextX), hl
	pop hl
	ret

; Draws the character A at TextX, TextY
PutChar:
	push hl
	push bc
	push de
	push af
	ld de, 5
	sub 20h
	call DEMulA
	ex hl, de
	ld ix, Font
	add ix, de
	ld b, 5
	ld a, (TextX)
	ld d, a
	add a, 4
	ld (TextX), a
	ld a, (TextY)
	ld e, a
	call PutSpriteOR
	pop af
	pop de
	pop bc
	pop hl
	ret

; Measures (HL) and returns width, height in b, c
MeasureString:
	ld bc, 0
	ld a, (hl)
	inc hl
	cp '\n'
	jr z, MeasureStringNewline
	cp '\r'
	jr z, MeasureStringNewline
	or a
	ret z
	ld a, 4
	add b, a
	jr MeasureString
	ret
MeasureStringNewline:
	ld a, 6
	add c, a
	ret

; Draws (HL) at TextX, TextY
DrawString:
	ld a, (hl)
	inc hl
	cp '\n'
	jr z, DrawStringNewline
	cp '\r'
	jr z, DrawStringNewline
	or a
	ret z
	call PutChar
	jr DrawString
DrawStringNewline:
	ld a, (TextY)
	add a, 6
	ld (TextY), a
	ld a, 0
	ld (TextX), a
	jr DrawString
